Index: /palm/trunk/SOURCE/urban_surface_mod.f90
===================================================================
--- /palm/trunk/SOURCE/urban_surface_mod.f90	(revision 3273)
+++ /palm/trunk/SOURCE/urban_surface_mod.f90	(revision 3274)
@@ -28,4 +28,7 @@
 ! -----------------
 ! $Id$
+! Modularization of all bulk cloud physics code components
+! 
+! 3248 2018-09-14 09:42:06Z sward
 ! Minor formating changes
 ! 
@@ -331,13 +334,10 @@
 #if ! defined( __nopointer )
     USE arrays_3d,                                                             &
-        ONLY:  dzu, hyp, zu, pt, pt_1, pt_2, p, u, v, w, hyp, tend
+        ONLY:  dzu, hyp, zu, pt, pt_1, pt_2, p, u, v, w, hyp, tend, exner
 #endif
 
-    USE cloud_parameters,                                                      &
-        ONLY:  cp, r_d
-
-    USE constants,                                                             &
-        ONLY:  pi
-    
+    USE basic_constants_and_equations_mod,                                     &
+        ONLY:  c_p, g, kappa, pi, r_d
+
     USE control_parameters,                                                    &
         ONLY:  coupling_start_time, topography, dt_3d, humidity,               &
@@ -346,7 +346,7 @@
                timestep_scheme, tsc, coupling_char, io_blocks, io_group,       &
                message_string, time_since_reference_point, surface_pressure,   &
-               g, pt_surface, large_scale_forcing, lsf_surf, spinup,           &
+               pt_surface, large_scale_forcing, lsf_surf, spinup,              &
                spinup_pt_mean, spinup_time, time_do3d, dt_do3d,                &
-               average_count_3d, varnamelength, urban_surface, kappa,          &
+               average_count_3d, varnamelength, urban_surface,                 &
                plant_canopy
 
@@ -376,6 +376,5 @@
         ONLY:  albedo_type, radiation_interaction, calc_zenith, zenith,        &
                radiation, rad_sw_in, rad_lw_in, rad_sw_out, rad_lw_out,        &
-               sigma_sb, solar_constant, sun_direction, sun_dir_lat,           &
-               sun_dir_lon,                                                    &
+               sigma_sb, sun_direction, sun_dir_lat, sun_dir_lon,              &
                force_radiation_call, surfinsw, surfinlw, surfinswdir,          &
                surfinswdif, surfoutsw, surfoutlw, surfins,nsvfl, svf, svfsurf, &
@@ -3603,5 +3602,4 @@
         REAL(wp)     ::  ground_floor_level_l         !< local height of ground floor level
         REAL(wp)     ::  z_agl                        !< height above ground
-        REAL(wp), DIMENSION(nzb:nzt)   ::  exn        !< value of the Exner function in layers
 
 !
@@ -4690,9 +4688,4 @@
         IF ( TRIM( initializing_actions ) /= 'read_restart_data'  .AND.        &
              TRIM( initializing_actions ) /= 'cyclic_fill' )  THEN
-       
-!--         Calculate initial surface temperature from pt of adjacent gridbox
-#if ! defined( __nopointer )
-            exn(nzb:nzt) = (hyp(nzb:nzt) / 100000.0_wp )**0.286_wp          !< Exner function
-#endif
 
 !
@@ -4705,8 +4698,8 @@
                k = surf_usm_h%k(m)
 
-               t_surf_h(m) = pt(k,j,i) * exn(k)
-               t_surf_window_h(m) = pt(k,j,i) * exn(k)
-               t_surf_green_h(m) = pt(k,j,i) * exn(k)
-               surf_usm_h%pt_surface(m) = pt(k,j,i) * exn(k)
+               t_surf_h(m) = pt(k,j,i) * exner(k)
+               t_surf_window_h(m) = pt(k,j,i) * exner(k)
+               t_surf_green_h(m) = pt(k,j,i) * exner(k)
+               surf_usm_h%pt_surface(m) = pt(k,j,i) * exner(k)
             ENDDO
 !
@@ -4718,8 +4711,8 @@
                   k = surf_usm_v(l)%k(m)
 
-                  t_surf_v(l)%t(m) = pt(k,j,i) * exn(k)
-                  t_surf_window_v(l)%t(m) = pt(k,j,i) * exn(k)
-                  t_surf_green_v(l)%t(m) = pt(k,j,i) * exn(k)
-                  surf_usm_v(l)%pt_surface(m) = pt(k,j,i) * exn(k)
+                  t_surf_v(l)%t(m) = pt(k,j,i) * exner(k)
+                  t_surf_window_v(l)%t(m) = pt(k,j,i) * exner(k)
+                  t_surf_green_v(l)%t(m) = pt(k,j,i) * exner(k)
+                  surf_usm_v(l)%pt_surface(m) = pt(k,j,i) * exner(k)
                ENDDO
             ENDDO
@@ -7338,5 +7331,4 @@
         REAL(wp)                              :: lambda_surface_window !< current value of lambda_surface (heat conductivity between air and window)
         REAL(wp)                              :: lambda_surface_green  !< current value of lambda_surface (heat conductivity between air and greeb wall)
-        REAL(wp), DIMENSION(nzb:nzt)          :: exn                !< value of the Exner function in layers
         
         REAL(wp)                              :: dtime              !< simulated time of day (in UTC)
@@ -7345,7 +7337,4 @@
 
 
-#if ! defined( __nopointer )
-        exn(nzb:nzt) = (hyp(nzb:nzt) / 100000.0_wp )**0.286_wp          !< Exner function
-#endif
 !        
 !--     First, treat horizontal surface elements
@@ -7371,6 +7360,6 @@
 #if ! defined( __nopointer )
 !
-!--        calculate rho * cp coefficient at surface layer
-           rho_cp  = cp * hyp(k) / ( r_d * surf_usm_h%pt1(m) * exn(k) )
+!--        calculate rho * c_p coefficient at surface layer
+           rho_cp  = c_p * hyp(k) / ( r_d * surf_usm_h%pt1(m) * exner(k) )
 #endif
 !
@@ -7387,9 +7376,9 @@
            surf_usm_h%r_a_green(m)  = surf_usm_h%r_a(m)
 
-!            r_a = ( surf_usm_h%pt1(m) - t_surf_h(m) / exn(k) ) /                              &
+!            r_a = ( surf_usm_h%pt1(m) - t_surf_h(m) / exner(k) ) /                              &
 !                  ( surf_usm_h%ts(m) * surf_usm_h%us(m) + 1.0E-20_wp )
-!            r_a_window = ( surf_usm_h%pt1(m) - t_surf_window_h(m) / exn(k) ) /                &
+!            r_a_window = ( surf_usm_h%pt1(m) - t_surf_window_h(m) / exner(k) ) /                &
 !                  ( surf_usm_h%ts(m) * surf_usm_h%us(m) + 1.0E-20_wp )
-!            r_a_green = ( surf_usm_h%pt1(m) - t_surf_green_h(m) / exn(k) ) /                  &
+!            r_a_green = ( surf_usm_h%pt1(m) - t_surf_green_h(m) / exner(k) ) /                  &
 !                  ( surf_usm_h%ts(m) * surf_usm_h%us(m) + 1.0E-20_wp )
                 
@@ -7446,11 +7435,11 @@
            coef_2 = 4.0_wp * surf_usm_h%emissivity(ind_veg_wall,m) *           &
                              sigma_sb * t_surf_h(m) ** 3                       &
-                           + lambda_surface + f_shf / exn(k)
+                           + lambda_surface + f_shf / exner(k)
            coef_window_2 = 4.0_wp * surf_usm_h%emissivity(ind_wat_win,m) *     &
                              sigma_sb * t_surf_window_h(m) ** 3                &
-                           + lambda_surface_window + f_shf_window / exn(k)
+                           + lambda_surface_window + f_shf_window / exner(k)
            coef_green_2 = 4.0_wp * surf_usm_h%emissivity(ind_pav_green,m) *    &
                              sigma_sb * t_surf_green_h(m) ** 3                 &
-                           + lambda_surface_green + f_shf_green / exn(k)
+                           + lambda_surface_green + f_shf_green / exner(k)
 
 !--        implicit solution when the surface layer has no heat capacity,
@@ -7480,5 +7469,5 @@
                                + surf_usm_h%frac(ind_wat_win,m) * t_surf_window_h_p(m)   &
                                + surf_usm_h%frac(ind_pav_green,m) * t_surf_green_h_p(m) )  &
-                               / exn(k)
+                               / exner(k)
                                
            IF ( humidity )  surf_usm_h%vpt_surface(m) =                        &
@@ -7540,14 +7529,14 @@
 !
 !--        ground/wall/roof surface heat flux
-           surf_usm_h%wshf_eb(m)   = - f_shf  * ( surf_usm_h%pt1(m) - t_surf_h_p(m) / exn(k) ) *               &
+           surf_usm_h%wshf_eb(m)   = - f_shf  * ( surf_usm_h%pt1(m) - t_surf_h_p(m) / exner(k) ) *               &
                                        surf_usm_h%frac(ind_veg_wall,m)         &
-                                     - f_shf_window  * ( surf_usm_h%pt1(m) - t_surf_window_h_p(m) / exn(k) ) * &
+                                     - f_shf_window  * ( surf_usm_h%pt1(m) - t_surf_window_h_p(m) / exner(k) ) * &
                                        surf_usm_h%frac(ind_wat_win,m)          &
-                                     - f_shf_green  * ( surf_usm_h%pt1(m) - t_surf_green_h_p(m) / exn(k) ) *   &
+                                     - f_shf_green  * ( surf_usm_h%pt1(m) - t_surf_green_h_p(m) / exner(k) ) *   &
                                        surf_usm_h%frac(ind_pav_green,m)
 !           
 !--        store kinematic surface heat fluxes for utilization in other processes
 !--        diffusion_s, surface_layer_fluxes,...
-           surf_usm_h%shf(m) = surf_usm_h%wshf_eb(m) / cp
+           surf_usm_h%shf(m) = surf_usm_h%wshf_eb(m) / c_p
 
        ENDDO
@@ -7573,6 +7562,6 @@
 #if ! defined( __nopointer )          
 !
-!--          calculate rho * cp coefficient at surface layer
-             rho_cp  = cp * hyp(k) / ( r_d * surf_usm_v(l)%pt1(m) * exn(k) )
+!--          calculate rho * c_p coefficient at surface layer
+             rho_cp  = c_p * hyp(k) / ( r_d * surf_usm_v(l)%pt1(m) * exner(k) )
 #endif
 
@@ -7647,11 +7636,11 @@
               coef_2 = 4.0_wp * surf_usm_v(l)%emissivity(ind_veg_wall,m) *     &
                                 sigma_sb * t_surf_v(l)%t(m) ** 3               &
-                              + lambda_surface + f_shf / exn(k)
+                              + lambda_surface + f_shf / exner(k)
               coef_window_2 = 4.0_wp * surf_usm_v(l)%emissivity(ind_wat_win,m) *&
                                 sigma_sb * t_surf_window_v(l)%t(m) ** 3        &
-                              + lambda_surface_window + f_shf / exn(k)
+                              + lambda_surface_window + f_shf / exner(k)
               coef_green_2 = 4.0_wp * surf_usm_v(l)%emissivity(ind_pav_green,m) *&
                                 sigma_sb * t_surf_green_v(l)%t(m) ** 3         &
-                              + lambda_surface_green + f_shf / exn(k)
+                              + lambda_surface_green + f_shf / exner(k)
 
 !--           implicit solution when the surface layer has no heat capacity,
@@ -7684,5 +7673,5 @@
                                       + surf_usm_v(l)%frac(ind_wat_win,m) * t_surf_window_v_p(l)%t(m)  &
                                       + surf_usm_v(l)%frac(ind_pav_green,m) * t_surf_green_v_p(l)%t(m) ) &
-                                      / exn(k) 
+                                      / exner(k)
                                       
               IF ( humidity )  surf_usm_v(l)%vpt_surface(m) =                  &
@@ -7751,14 +7740,14 @@
               surf_usm_v(l)%wshf_eb(m)   =                                     &
                  - f_shf  * ( surf_usm_v(l)%pt1(m) -                           &
-                 t_surf_v_p(l)%t(m) / exn(k) ) * surf_usm_v(l)%frac(ind_veg_wall,m)       &
+                 t_surf_v_p(l)%t(m) / exner(k) ) * surf_usm_v(l)%frac(ind_veg_wall,m)       &
                  - f_shf_window  * ( surf_usm_v(l)%pt1(m) -                    &
-                 t_surf_window_v_p(l)%t(m) / exn(k) ) * surf_usm_v(l)%frac(ind_wat_win,m)&
+                 t_surf_window_v_p(l)%t(m) / exner(k) ) * surf_usm_v(l)%frac(ind_wat_win,m)&
                  - f_shf_green  * ( surf_usm_v(l)%pt1(m) -                     &
-                 t_surf_green_v_p(l)%t(m) / exn(k) ) * surf_usm_v(l)%frac(ind_pav_green,m)
+                 t_surf_green_v_p(l)%t(m) / exner(k) ) * surf_usm_v(l)%frac(ind_pav_green,m)
 
 !           
 !--           store kinematic surface heat fluxes for utilization in other processes
 !--           diffusion_s, surface_layer_fluxes,...
-              surf_usm_v(l)%shf(m) = surf_usm_v(l)%wshf_eb(m) / cp
+              surf_usm_v(l)%shf(m) = surf_usm_v(l)%wshf_eb(m) / c_p
 
            ENDDO
@@ -7790,5 +7779,5 @@
                          (dtime/3600.0_wp-REAL(dhour,wp))*aheatprof(k,dhour+1)
                  IF ( aheat(k,j,i) > 0.0_wp )  THEN
-                    pt(k,j,i) = pt(k,j,i) + aheat(k,j,i)*acoef*dt_3d/(exn(k)*rho_cp*dzu(k))
+                    pt(k,j,i) = pt(k,j,i) + aheat(k,j,i)*acoef*dt_3d/(exner(k)*rho_cp*dzu(k))
                  ENDIF
               ENDIF
Index: /palm/trunk/SOURCE/uv_exposure_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/uv_exposure_model_mod.f90	(revision 3273)
+++ /palm/trunk/SOURCE/uv_exposure_model_mod.f90	(revision 3274)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Modularization of all bulk cloud physics code components
+! 
+! 3248 2018-09-14 09:42:06Z sward
 ! Minor formating changes
 ! 
@@ -77,5 +80,8 @@
 !------------------------------------------------------------------------------!
  MODULE uv_exposure_model_mod
- 
+
+
+    USE basic_constants_and_equations_mod,                                     &
+        ONLY:  pi
 
     USE kinds
@@ -640,8 +646,5 @@
 !> Module-specific routine for new module
 !------------------------------------------------------------------------------!
- SUBROUTINE uvem_solar_position 
-
-    USE constants,                                                             &
-       ONLY:  pi
+ SUBROUTINE uvem_solar_position
     
     USE date_and_time_mod,                                                     &
@@ -713,7 +716,4 @@
 !------------------------------------------------------------------------------!
  SUBROUTINE uvem_calc_exposure
-    
-    USE constants,                                                             &
-        ONLY:  pi
 
     USE indices,                                                               &
Index: /palm/trunk/SOURCE/virtual_flight_mod.f90
===================================================================
--- /palm/trunk/SOURCE/virtual_flight_mod.f90	(revision 3273)
+++ /palm/trunk/SOURCE/virtual_flight_mod.f90	(revision 3274)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Modularization of all bulk cloud physics code components
+! 
+! 3248 2018-09-14 09:42:06Z sward
 ! Minor formating changes
 ! 
@@ -311,5 +314,5 @@
     SUBROUTINE flight_init
  
-       USE constants,                                                          &
+       USE basic_constants_and_equations_mod,                                  &
            ONLY:  pi
     
@@ -410,7 +413,9 @@
     
        USE control_parameters,                                                 &
-          ONLY:  cloud_droplets, cloud_physics, humidity, neutral,             &
-                 passive_scalar
-          
+          ONLY:  cloud_droplets, humidity, neutral, passive_scalar
+
+       USE bulk_cloud_model_mod,                                               &
+           ONLY:  bulk_cloud_model
+
        USE netcdf_interface
     
@@ -441,5 +446,5 @@
           id_q       = num_var_fl
        ENDIF
-       IF ( cloud_physics .OR. cloud_droplets )  THEN
+       IF ( bulk_cloud_model .OR. cloud_droplets )  THEN
           num_var_fl = num_var_fl + 1  
           id_ql      = num_var_fl
@@ -533,5 +538,5 @@
 
        USE control_parameters,                                                 &
-           ONLY:  cloud_droplets, cloud_physics, dt_3d, humidity, neutral,     &
+           ONLY:  cloud_droplets, dt_3d, humidity, neutral,                    &
                   passive_scalar, simulated_time
                   
@@ -544,4 +549,7 @@
        USE indices,                                                            &
            ONLY:  nx, nxl, nxr, ny, nys, nyn
+
+       USE bulk_cloud_model_mod,                                               &
+           ONLY:  bulk_cloud_model
 
        USE pegrid
@@ -712,5 +720,5 @@
 !
 !--             Liquid water content
-                IF ( cloud_physics .OR. cloud_droplets )  THEN
+                IF ( bulk_cloud_model .OR. cloud_droplets )  THEN
                    CALL interpolate_xyz( ql, zu, ddzu, 1.0_wp, x, y, var_index, j, i )
                    var_index = var_index + 1
Index: /palm/trunk/SOURCE/wind_turbine_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/wind_turbine_model_mod.f90	(revision 3273)
+++ /palm/trunk/SOURCE/wind_turbine_model_mod.f90	(revision 3274)
@@ -26,4 +26,7 @@
 ! -----------------
 ! $Id$
+! Modularization of all bulk cloud physics code components
+! 
+! 3248 2018-09-14 09:42:06Z sward
 ! Minor formating changes
 ! 
@@ -175,5 +178,5 @@
         ONLY:  tend, u, v, w, zu, zw
 
-    USE constants,                                                             &
+    USE basic_constants_and_equations_mod,                                     &
         ONLY:  pi
 
Index: /palm/trunk/SOURCE/write_restart_data_mod.f90
===================================================================
--- /palm/trunk/SOURCE/write_restart_data_mod.f90	(revision 3273)
+++ /palm/trunk/SOURCE/write_restart_data_mod.f90	(revision 3274)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Modularization of all bulk cloud physics code components
+! 
+! 3065 2018-06-12 07:03:02Z Giersch
 ! New parameters concerning vertical grid stretching have been added
 ! 
@@ -109,8 +112,6 @@
            ONLY:  nx, ny, nz
 
-       USE microphysics_mod,                                                   &
-           ONLY:  c_sedimentation, cloud_water_sedimentation,                  &
-                  collision_turbulence, limiter_sedimentation, nc_const,       &
-                  ventilation_effect
+       USE bulk_cloud_model_mod,                                               &
+           ONLY:  bulk_cloud_model, bcm_wrd_global
 
        USE model_1d_mod,                                                       &
@@ -264,7 +265,4 @@
        WRITE ( 14 )  building_wall_south
 
-       CALL wrd_write_string( 'c_sedimentation' ) 
-       WRITE ( 14 )  c_sedimentation
-
        CALL wrd_write_string( 'call_psolver_at_all_substeps' ) 
        WRITE ( 14 )  call_psolver_at_all_substeps
@@ -291,21 +289,9 @@
        WRITE ( 14 )  cloud_droplets
 
-       CALL wrd_write_string( 'cloud_physics' ) 
-       WRITE ( 14 )  cloud_physics
-
-       CALL wrd_write_string( 'cloud_scheme' ) 
-       WRITE ( 14 )  cloud_scheme
-
        CALL wrd_write_string( 'cloud_top_radiation' ) 
        WRITE ( 14 )  cloud_top_radiation
 
-       CALL wrd_write_string( 'cloud_water_sedimentation' ) 
-       WRITE ( 14 )  cloud_water_sedimentation
-
        CALL wrd_write_string( 'collective_wait' ) 
        WRITE ( 14 )  collective_wait
-
-       CALL wrd_write_string( 'collision_turbulence' ) 
-       WRITE ( 14 )  collision_turbulence
 
        CALL wrd_write_string( 'conserve_volume_flow' ) 
@@ -455,7 +441,4 @@
        WRITE ( 14 )  latitude
 
-       CALL wrd_write_string( 'limiter_sedimentation' ) 
-       WRITE ( 14 )  limiter_sedimentation
-
        CALL wrd_write_string( 'longitude' )
        WRITE ( 14 )  longitude 
@@ -487,7 +470,4 @@
        WRITE ( 14 )  most_method
 
-       CALL wrd_write_string( 'nc_const' ) 
-       WRITE ( 14 )  nc_const
-
        CALL wrd_write_string( 'netcdf_precision' ) 
        WRITE ( 14 )  netcdf_precision
@@ -537,7 +517,4 @@
        CALL wrd_write_string( 'prandtl_number' ) 
        WRITE ( 14 )  prandtl_number
-
-       CALL wrd_write_string( 'precipitation' ) 
-       WRITE ( 14 )  precipitation
 
        CALL wrd_write_string( 'psolver' )
@@ -848,7 +825,4 @@
        WRITE ( 14 )  v_max_ijk
 
-       CALL wrd_write_string( 'ventilation_effect' ) 
-       WRITE ( 14 )  ventilation_effect
-
        CALL wrd_write_string( 'vg' ) 
        WRITE ( 14 )  vg
@@ -927,4 +901,8 @@
 !-- The order of the calls can be different as in read_restart_data_mod where
 !-- the restart data will be read 
+
+!
+!-- If required, write restart data for gust module.
+       IF ( bulk_cloud_model )  CALL bcm_wrd_global
 !
 !-- If required, write restart data for wind turbine model.
@@ -962,10 +940,12 @@
 
        USE arrays_3d,                                                          &
-           ONLY:  e, kh, km, p, pt, q, ql, qc, nc, nr, prr,                    &
-                  precipitation_amount, qr, s, sa, u, u_m_l, u_m_n, u_m_r,     &
+           ONLY:  e, kh, km, p, pt, q, ql, s, sa, u, u_m_l, u_m_n, u_m_r,      &
                   u_m_s, v, v_m_l, v_m_n, v_m_r, v_m_s, vpt, w, w_m_l, w_m_n,  &
                   w_m_r, w_m_s
         
        USE averaging
+
+       USE bulk_cloud_model_mod,                                               &
+           ONLY:  bulk_cloud_model, bcm_wrd_local
 
        USE chemistry_model_mod,                                                &
@@ -980,5 +960,5 @@
        USE land_surface_model_mod,                                             &
            ONLY:  lsm_wrd_local
-        
+
        USE particle_attributes,                                                &
            ONLY:  iran_part
@@ -1078,19 +1058,4 @@
        ENDIF
 
-       IF ( ALLOCATED( prr ) )  THEN
-          CALL wrd_write_string( 'prr' ) 
-          WRITE ( 14 )  prr
-       ENDIF
-
-       IF ( ALLOCATED( prr_av ) )  THEN
-          CALL wrd_write_string( 'prr_av' ) 
-          WRITE ( 14 )  prr_av
-       ENDIF
-
-       IF ( ALLOCATED( precipitation_amount ) )  THEN
-          CALL wrd_write_string( 'precipitation_amount' ) 
-          WRITE ( 14 )  precipitation_amount
-       ENDIF
-
        CALL wrd_write_string( 'pt' ) 
        WRITE ( 14 )  pt
@@ -1111,56 +1076,14 @@
           ENDIF
 
-          IF ( cloud_physics  .OR.  cloud_droplets )  THEN
-
-             CALL wrd_write_string( 'ql' ) 
+          IF ( cloud_droplets )  THEN
+
+             CALL wrd_write_string( 'ql' )
              WRITE ( 14 )  ql
 
              IF ( ALLOCATED( ql_av ) )  THEN
-                CALL wrd_write_string( 'ql_av' ) 
+                CALL wrd_write_string( 'ql_av' )
                 WRITE ( 14 )  ql_av
              ENDIF
 
-             IF ( .NOT. cloud_droplets )  THEN
-
-                CALL wrd_write_string( 'qc' ) 
-                WRITE ( 14 )  qc
-
-                IF ( ALLOCATED( qc_av ) )  THEN
-                   CALL wrd_write_string( 'qc_av' ) 
-                   WRITE ( 14 )  qc_av
-                ENDIF
-
-                IF ( microphysics_morrison )  THEN
-
-                   CALL wrd_write_string( 'nc' ) 
-                   WRITE ( 14 )  nc
-
-                   IF ( ALLOCATED( nc_av ) )  THEN
-                      CALL wrd_write_string( 'nc_av' ) 
-                      WRITE ( 14 )  nc_av
-                   ENDIF
-
-                ENDIF
-
-                IF ( microphysics_seifert )  THEN
-
-                   CALL wrd_write_string( 'nr' ) 
-                   WRITE ( 14 )  nr
-
-                   IF ( ALLOCATED( nr_av ) )  THEN
-                      CALL wrd_write_string( 'nr_av' ) 
-                      WRITE ( 14 )  nr_av
-                   ENDIF
-
-                   CALL wrd_write_string( 'qr' ) 
-                   WRITE ( 14 )  qr
-
-                   IF ( ALLOCATED( qr_av ) )  THEN
-                      CALL wrd_write_string( 'qr_av' ) 
-                      WRITE ( 14 )  qr_av
-                   ENDIF
-
-                ENDIF
-             ENDIF
           ENDIF
 
@@ -1387,4 +1310,10 @@
 
 !
+!-- If required, write restart data for microphysics module.
+       IF ( bulk_cloud_model )  THEN
+          CALL bcm_wrd_local
+       ENDIF
+
+!
 !-- Write surface-related restart data.
        CALL surface_wrd_local
